' *******************************************************************************************************
' *                                                                                                     *
' *     AiChip_TvText_Demo_001.spin                                                                     *
' *                                                                                                     *
' *******************************************************************************************************

CON

  _CLKMODE                      = XTAL1 + PLL16x
  _XINFREQ                      = 5_000_000                                           

  USB_PIN_DMINUS                = 11           
  USB_PIN_DPLUS                 = 10
  USB_PIN_ENABLE                = 15
    
' *******************************************************************************************************
' *                                                                                                     *
' *     Main Program. No need to edit below here, just change settings above                            *
' *                                                                                                     *
' *******************************************************************************************************

OBJ

  io                            : "AiChip_IoHandler_002"

CON

' .-----------------------------------------------------------------------------------------------------.
' |                                                                                                     |
' |     Device Routing                                                                                  |
' |                                                                                                     |
' `-----------------------------------------------------------------------------------------------------'
 
  ROUTE_NONE                    = io#ROUTE_NONE
  ROUTE_RX                      = io#ROUTE_RX
  ROUTE_TX                      = io#ROUTE_TX
  ROUTE_TV                      = io#ROUTE_TV
  ROUTE_LCD                     = io#ROUTE_LCD
  ROUTE_USB                     = io#ROUTE_USB

' .-----------------------------------------------------------------------------------------------------.
' |                                                                                                     |
' |     USB Pin Mapping                                                                                 |
' |                                                                                                     |
' `-----------------------------------------------------------------------------------------------------'

 USB_PINS                       = USB_PIN_DMINUS << 16 | USB_PIN_DPLUS << 8 | USB_PIN_ENABLE

' *******************************************************************************************************
' *                                                                                                     *
' *     Demonstration Program                                                                           *
' *                                                                                                     *
' *******************************************************************************************************

VAR

  long usbKickCount
 
PUB Demo

  Demo_Usb(String("AiChip_USB_Demo_001"))

  repeat
    PauseMs( 1000 )
    Kick_Usb( ++usbKickCount )
        
PRI Demo_Usb( description )

  result := Open( ROUTE_USB, USB_PINS, 0 )

  PauseMs( 20000 )
  
  TxText(description)
  TxCrLf
  TxCrLf

PRI Kick_Usb( n )

  Open( ROUTE_USB, USB_PINS, 0 )

  TxNumberFormat( n, 10, 0)
  TxByte(" ")

' *******************************************************************************************************
' *                                                                                                     *
' *     Timing Routines                                                                                 *
' *                                                                                                     *
' *******************************************************************************************************

PRI PauseMs( mS )

  waitcnt( ( clkfreq / 1000 ) * mS + cnt )

' *******************************************************************************************************
' *                                                                                                     *
' *     Vectors into the IO handler                                                                     *
' *                                                                                                     *
' *******************************************************************************************************

PUB Open( setDeviceType, setBasePin, setMode )
  io.Open( setDeviceType, setBasePin, setMode )

PUB Close( setDeviceType )
  io.Close( setDeviceType )

PUB Route( setDeviceType )
  result := io.Route( setDeviceType )

PUB GetMode( setDeviceType )
  result := io.GetMode( setDeviceType )
          
PUB TxText( txtPtr )
  io.TxText( txtPtr )

PUB TxByte( b )
  io.TxByte( b )
  
PUB TxRawByte( b )
  io.TxRawByte( b )

PUB TxCrLf
  io.TxCrLf
    
PUB Cls
  io.Cls
  
PUB Home
  io.Home
  
PUB TxTab
  io.TxTab
  
PUB TxBackSpace
  io.TxBackSpace

PUB TxNumberFormat( n, radix, width )
  io.TxNumberFormat( n, radix, width )
 
PUB TxNumber( n )
  io.TxNumber( n )

PUB RxByte( b ) : rxd
  rxd := io.RxByte

PUB RxFlush
  io.RxFlush

PUB RxIfAvailable : rxd
  rxd := io.RxIfAvailable
      
PUB GetColourCount
  result := io.GetColourCount

PUB GetColumnCount
  result := io.GetColumnCount

PUB GetRowCount
  result := io.GetRowCount
  
PUB GetCurrentColumn
  result := io.GetCurrentColumn
  
PUB GetCurrentRow
  result := io.GetCurrentRow
    
PUB SetPalette( ptrToPalette )
  io.SetPalette( ptrToPalette )
               
PUB SetPaletteColour( colorIdx, fore, back )
  io.SetPaletteColour( colorIdx, fore, back )

' *******************************************************************************************************
' *                                                                                                     *
' *     End of AiChip_TvText_Demo_001.spin                                                              *
' *                                                                                                     *
' *******************************************************************************************************